<template>


<div class="">

  <a class="nav-link pr-2"><i class="fa fa-shopping-cart fa-3x" data-toggle="modal" data-target="#cartmodal"></i>{{totale}}</a>
 


<!-- Modal -->
<div  class="modal fade" id="cartmodal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
  aria-hidden="true" v-for="producto in productos">
  <div class="modal-dialog modal-dialog-slideout" role="document">
    <div class="modal-content">
      <div class="modal-header btn-primary">
        <h5  style="margin-left:550px;" id="exampleModalLabel">Carro Compra</h5>
        <button type="button" class="close" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
         
          <table style="margin-left:5px;" class="table table-striped table-collapse">
            <thead class="btn-Warning">
              <tr>
                <th style="text-align:center;">Producto</th>
                <th>Precio</th>
                <th style="text-align:center">Cantidad</th>
                <th><span style="text-align:center">SubTotal</span></th>
                <th></th>
              </tr>
            </thead>
            <tbody v-for="producto in carrito">
              <tr>
                <td data-th="Product">
                  <div class="media">
                    <div class="cart-image pull-left">
                      <img class="img" :src="producto.imagen" alt="producto.nombre" />
                      <div style="margin-left:60px;" v-model="productoventa.producto_id" class="product-name">{{producto.nombre}}</div>
                    </div>
                  </div>
                </td>
                <td data-th="Price">${{producto.precio}}</td>
                <td data-th="Quantity">
                  
                 <number-input style="margin-inline:220px"  controls size="small"  :min="1" :max="producto.stock" :inputtable="false" v-model="producto.cantidad" ></number-input>
                </td>
                <td data-th="Total">
                  <span  class="pull-center">${{calcularSubTotal(producto)}}</span>
                </td>
                  <button style="margin-top:62%" @click="remove(producto)" class="btn btn-danger">eliminar</button> 
              </tr>
              
            </tbody>
            <tfoot>
              <tr class="text-right">
                <td colspan="4">
                  <dl class="dl-horizontal pull-right">
                    <h2>Descuento:</h2>
                    <dd class="text-right">&#x24;0.00</dd>
                    <h2>Total:</h2>
                    <dd class="text-right">total: ${{totalprecio}}</dd>
                  </dl>
                </td>
                <td></td>
              </tr>
            </tfoot>
          </table>
          <p>
            <form  action="#" v-if="totale >=1" >
              <button style="margin-left:5px;" type="button" @click="create" class="btn btn-success btn-block"  data-target="#checkout" data-toggle="modal" >Comprar</button>
            </form>
          </p>
        </form>


      </div>
      <div class="modal-footer">
       <!--<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <button type="button" class="btn btn-primary">Save changes</button>
    -->         

      </div>
    </div>
  </div>
</div>

<div  class="modal fade" id="checkout" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
  aria-hidden="true" v-for="producto in productos">
  <div class="modal-dialog modal-dialog-slideout" role="document">
    <div class="modal-content">
      <div class="modal-header btn-primary">
        <h5  style="margin-left:550px;" id="exampleModalLabel">CHECKOUT</h5>
      </div>
      <div class="modal-body">
       
           <h1>Datos usuario</h1>
         <table style="margin-left:3px;" class="table table-striped table-collapse">
           <thead>
             <tr>
               <th>Rut</th>
               <th>Nombre</th>
               <th>Email</th>
               <th>Telefono</th>
               <th>Direccion</th>
             </tr>
           </thead>
           <tbody>
             <tr>
               <td>{{rut}}</td>
                 <td>{{user}}</td>
                   <td>{{email}}</td>
                     <td>{{telefono}}</td>
                       <td>{{direccion}}</td>
             </tr>
           </tbody>
         </table>

         <h1>Productos</h1>
          <table style="margin-left:3px;" class="table table-striped table-collapse">
            <thead class="btn-Warning">
              <tr>
                <th >nombre</th>
                <th>Precio</th>
                <th >Cantidad</th>
                <th><span >SubTotal</span></th>
                <th></th>
              </tr>
            </thead>
            <tbody v-for="producto in carrito">
              <tr>
                <td data-th="Product">
                  <div class="media">
                    <div class="cart-image pull-left">
                      <img class="img" :src="producto.imagen" alt="producto.nombre" />
                      <div v-model="productoventa.producto_id" class="product-name">{{producto.nombre}}</div>
                    </div>
                  </div>
                </td>
                <td data-th="Price">${{producto.precio}}</td>
               
                  
                 <td v-model="producto.cantidad">{{producto.cantidad}}</td>
                
                <td data-th="Total">
                  <span  class="pull-center">${{calcularSubTotal(producto)}}</span>
                </td>
                  
              </tr>
              
            </tbody>
            <tfoot>
              <tr class="text-right">
                <td colspan="4">
                  <dl class="dl-horizontal pull-right">
                    <h2>Descuento:</h2>
                    <dd class="text-right">&#x24;0.00</dd>
                    <h2>Total:</h2>
                    <dd class="text-right">total: ${{totalprecio}}</dd>
                  </dl>
                </td>
                <td></td>
              </tr>
            </tfoot>
       
          </table>
        
            <form action="/menu" >
              <button style="margin-left:5px;"  type="submit" @click="sacar" class="btn btn-success btn-block" >Seguir Comprando</button>
            </form>
          </p>
        </form>


      </div>
      <div class="modal-footer">
       <!--<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
        <button type="button" class="btn btn-primary">Save changes</button>
    -->         

      </div>
    </div>
  </div>
</div>






</div>
</template>

<script>

    export default {

    	components:{

    	},
      
    	data() {
			return {
			 productos:[],
       usuarios:[],

      

    
     productoventa:{
        fecha_venta:new Date().toISOString().slice(0,10),
        user_id:'',
        total:'',
       },
			}
		},
    props:["carrito","productoventas","user","email","rut","telefono","direccion"],
    
    computed:{
    totale:function(){
         let totale=0;
        for (var i = 0; i < this.carrito.length; i++) {
       totale += this.cantidad(this.carrito[i])
        }
        return this.productoventa.cantidad = totale;
    },
    
    totalprecio:function(){
        let totalprecio=0;
        for (var i = 0; i < this.carrito.length; i++) {
       totalprecio += this.calcularSubTotal(this.carrito[i])
        }
        return  this.productoventa.total=totalprecio  
    },
      userid:function(){
       return this.productoventa.user_id = window.userId;
      }
  },
		mounted(){
			this.fetchdata();
      this.us();
      //console.log(this.carrito);
		},
		methods:{
			fetchdata(){
				const self = this;
				axios.get('api/productos').then(function(response){
					self.productos = response.data.map(function (prod) {
            
            prod.cantidad = 1;
            return prod;
          });
					
				})
			},
        us(){
        const self = this;
        axios.get('api/detallecompra').then(function(response){
          self.usuarios = response.data;

          self.usuarios=user;

          
        })
      },
      calcularSubTotal(producto) {
            return producto.cantidad * producto.precio
      },
         remove(producto){
            this.carrito.splice(this.carrito.indexOf(producto),1);
             this.$parent.localdata();
       },

        

       create(){

      if (confirm("Esta seguro de Comprar?")){
       const req={
        carrito:this.$parent.carrito,
        user_id:window.userId,
        fecha_venta:new Date().toISOString().slice(0,10),
        total:this.totalprecio
        }
        axios.post("api/producto_ventas",req).then(response=>{
          this.productoventa.fecha_venta=''
          this.productoventa.user_id=''
          this.productoventa.total=''
          })
        }
      },
       
       cantidad(producto){
        return producto.cantidad;
       },

       sacar(){
          return localStorage.removeItem('cart');
           alert("compra exitosa");
       },
      

  }
}
    

</script>

<style scoped>
/* Carrito */



.modal-dialog.modal-dialog-slideout {
width:500%;

}



.modal-dialog-slideout {

min-height:100%;
margin:0px;
left:20px;
background:#fff;

float:right;

max-width:103%;

}

.modal.fade 
.modal-dialog.modal-dialog-slideout {

-webkit-transform: 
translate(100%,0);

transform: 
translate(100%,0);

}

.modal.fade.show 
.modal-dialog.modal-dialog-slideout {

-webkit-transform: 
translate(0,0);

transform: 
translate(0,0);

flex-flow: 
column;

}

.modal-dialog-slideout 
.modal-content{

border:0;

}

tbody{
  border: 3px solid blue;
}


.table td, .table th {
    padding: .75rem;
    vertical-align: middle;
    border-top: 1px solid #dee2e6;
}
	.pull-left {
    float: left;
    margin-left: 25%;
}
.img{
  width:10em;
  height:10em;
}

</style>